<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class NodeTraffic extends MX_Controller {

    /**
     * Index Page for this controller.
     *
     * Past the login page this loads the page for /traffic/nodeTraffic.
     *
     */

    public function index() {

        $CI =& get_instance();
        
        // We load the BlueOnyx helper library first of all, as we heavily depend on it:
        $this->load->helper('blueonyx');
        init_libraries();

        // Need to load 'BxPage' for page rendering:
        $this->load->library('BxPage');
        $MX =& get_instance();

        // Get $sessionId and $loginName from Cookie (if they are set):
        $sessionId = $CI->input->cookie('sessionId');
        $loginName = $CI->input->cookie('loginName');
        $locale = $CI->input->cookie('locale');

        // Line up the ducks for CCE-Connection:
        include_once('ServerScriptHelper.php');
        $serverScriptHelper = new ServerScriptHelper($sessionId, $loginName);
        $cceClient = $serverScriptHelper->getCceClient();
        $user = $cceClient->getObject("User", array("name" => $loginName));
        $i18n = new I18n("base-traffic", $user['localePreference']);
        $system = $cceClient->getObject("System");

        // Initialize Capabilities so that we can poll the access rights as well:
        $Capabilities = new Capabilities($cceClient, $loginName, $sessionId);

        // -- Actual page logic start:

        // Not 'systemAdministrator'? Bye, bye!
        if (!$Capabilities->getAllowed('systemAdministrator')) {
            // Nice people say goodbye, or CCEd waits forever:
            $cceClient->bye();
            $serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403");
        }

        //
        //--- Handle form validation:
        //

        // We start without any active errors:
        $errors = array();
        $extra_headers =array();
        $ci_errors = array();
        $my_errors = array();

        // Shove submitted input into $form_data after passing it through the XSS filter:
        $form_data = $CI->input->post(NULL, TRUE);

        // Form fields that are required to have input:
        $required_keys = array( "", "");
        // Set up rules for form validation. These validations happen before we submit to CCE and further checks based on the schemas are done:

        // Empty array for key => values we want to submit to CCE:
        $attributes = array();
        // Items we do NOT want to submit to CCE:
        $ignore_attributes = array("BlueOnyx_Info_Text", "_serialized_errors");
        if (is_array($form_data)) {
            // Function GetFormAttributes() walks through the $form_data and returns us the $parameters we want to
            // submit to CCE. It intelligently handles checkboxes, which only have "on" set when they are ticked.
            // In that case it pulls the unticked status from the hidden checkboxes and addes them to $parameters.
            // It also transformes the value of the ticked checkboxes from "on" to "1". 
            //
            // Additionally it generates the form_validation rules for CodeIgniter.
            //
            // params: $i18n                i18n Object of the error messages
            // params: $form_data           array with form_data array from CI
            // params: $required_keys       array with keys that must have data in it. Needed for CodeIgniter's error checks
            // params: $ignore_attributes   array with items we want to ignore. Such as Labels.
            // return:                      array with keys and values ready to submit to CCE.
            $attributes = GetFormAttributes($i18n, $form_data, $required_keys, $ignore_attributes, $i18n);
        }
        //Setting up error messages:
        $CI->form_validation->set_message('required', $i18n->get("[[palette.val_is_required]]", false, array("field" => "\"%s\"")));        

        // Do we have validation related errors?
        if ($CI->form_validation->run() == FALSE) {

            if (validation_errors()) {
                // Set CI related errors:
                $ci_errors = array(validation_errors('<div class="alert dismissible alert_red"><img width="40" height="36" src="/.adm/images/icons/small/white/alarm_bell.png"><strong>', '</strong></div>'));
            }           
            else {
                // No errors. Pass empty array along:
                $ci_errors = array();
            }
        }

        //
        //--- Own error checks:
        //

        if ($CI->input->post(NULL, TRUE)) {

        }

        //
        //--- At this point all checks are done. If we have no errors, we can submit the data to CODB:
        //

        // Join the various error messages:
        $errors = array_merge($ci_errors, $my_errors);

        // If we have no errors and have POST data, we submit to CODB:
        if ((count($errors) == "0") && ($CI->input->post(NULL, TRUE))) {

        }

        //
        //-- Generate page:
        //

        $cceClient->setObjectForce("VserverTraffic", array('generate_graphs_id' => '999999', 'generate_graphs_single' => time()), '', array());

        // Prepare Page:
        $factory = $serverScriptHelper->getHtmlComponentFactory("base-traffic", "/traffic/nodeTraffic");
        $BxPage = $factory->getPage();
        $i18n = $factory->getI18n();

        $product = new Product($cceClient);

        // Set Menu items:
        $BxPage->setVerticalMenu('base_siteList1');
        $page_module = 'base_sitemanageVSL';
        $pageId = "siteDefaultsTab";

        // NICs:
        $netoids = $cceClient->findx('Network');
        natsort ($netoids);
        foreach ($netoids as $oid) {
            $netinfo = $cceClient->get($oid);
            if ($netinfo['enabled'] == "1") {
                $device = $netinfo['device'];

                $block[$oid] =& $factory->getPagedBlock("trafStatsNic", array($pageId));
                $block[$oid]->setLabel($factory->getLabel('trafStatsNic', false, array('device' => $device)));
                $block[$oid]->setToggle("#");
                $block[$oid]->setSideTabs(FALSE);
                //$block[$oid]->setShowAllTabs("#");
                $block[$oid]->setDefaultPage($pageId);

                // Add Divider:
                $block[$oid]->addFormField(
                        $factory->addBXDivider("Last_Day", ""),
                        $factory->getLabel("Last_Day", false),
                        $pageId
                        );

                $insertGfx = '<p align="center"><img src="/base/traffic/images/' . $device . '-day.png?x" alt=""/></p>';
                $block[$oid]->addFormField(
                        $factory->getRawHTML("ld", $insertGfx, "r"),
                        $factory->getLabel('ld'),
                        $pageId
                        );

                // Add Divider:
                $block[$oid]->addFormField(
                        $factory->addBXDivider("Last_Week", ""),
                        $factory->getLabel("Last_Week", false),
                        $pageId
                        );

                $insertGfx = '<p align="center"><img src="/base/traffic/images/' . $device . '-week.png?x" alt=""/></p>';
                $block[$oid]->addFormField(
                        $factory->getRawHTML("lw", $insertGfx, "r"),
                        $factory->getLabel('lw'),
                        $pageId
                        );

                // Add Divider:
                $block[$oid]->addFormField(
                        $factory->addBXDivider("Last_Month", ""),
                        $factory->getLabel("Last_Month", false),
                        $pageId
                        );

                $insertGfx = '<p align="center"><img src="/base/traffic/images/' . $device . '-month.png?x" alt=""/></p>';
                $block[$oid]->addFormField(
                        $factory->getRawHTML("lm", $insertGfx, "r"),
                        $factory->getLabel('lm'),
                        $pageId
                        );

                // Add Divider:
                $block[$oid]->addFormField(
                        $factory->addBXDivider("Last_Year", ""),
                        $factory->getLabel("Last_Year", false),
                        $pageId
                        );

                $insertGfx = '<p align="center"><img src="/base/traffic/images/' . $device . '-year.png?x" alt=""/></p>';
                $block[$oid]->addFormField(
                        $factory->getRawHTML("ly", $insertGfx, "r"),
                        $factory->getLabel('ly'),
                        $pageId
                        );

                $page_body[] = $block[$oid]->toHtml();
            }
        }

        // Nice people say goodbye, or CCEd waits forever:
        $cceClient->bye();
        $serverScriptHelper->destructor();

        // Out with the page:
        $BxPage->render($page_module, $page_body);

    }       
}
/*
Copyright (c) 2016 Michael Stauber, SOLARSPEED.NET
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/
?>